1000 REMark EDTPRT - Printer driver for text files - Chas Dillon Oct 87
1010 REMark          Revised January 2000 Mark Knight
1020 :
1030 TURBO_objfil"ram1_EdtPrt"
1040 TURBO_taskn "EdtPrt 2.01K"
1050 DATA_AREA  16
1060 TURBO_locstr "Ignore"
1070 :
1080 IMPLICIT%   ii, jj, kk, key_press
1090 :
1100 REMark          Extra cmds/fns: DEVICE_STATUS, CURSOR_ON, CURSOR_OFF
1110 REMark                          FWINDOW% - MK - Added January 2000
1120 :
1130 IF COMPILED THEN 
1140   WHEN_ERROR
1150     WINDOW SmallWidth%,SmallHeight%,SmallH%,SmallV% : BORDER 1,7 : PAPER 2 : INK 7
1160     CLS : PRINT \' An error has occurred ... (';ERNUM%!!ERLIN%;')'
1170     PRINT ' Please check correct volumes are loaded'
1180     PRINT ' and if necessary write enabled'
1190     PRINT \'    Press ENTER to retry; ESC to quit ';
1200     Get_Key : IF key_press = 27 : STOP
1210     BORDER 1,0: PAPER 0 : INK 4 : CLS : RETRY
1220   END WHEN 
1230 END IF 
1240 :
1250 DIM vers$(6) : vers$ = "2.01K"
1260 IF COMPILED
1270   OPEN #0,'con_100x100a50x50_128'
1280   OPEN #1,'con_100x100a50x50_128'
1290 END IF 
1300 Find_SCREENSIZE
1310 MANIFEST : max_exchanges%=60
1320 :
1330 DIM b$(256), x$(50)
1340 DIM prnm$(36), driver_fnm$(50)
1350 DIM instring$(512), outstring$(512), replacement$(360)
1360 DIM filename$(40)       : REMark File name of Print file
1370 DIM printer$(32)        : REMark Printer device name
1380 DIM pageid$(20)         : REMark Text on default page number line
1390 DIM device$(32)
1400 DIM default_device$(32)
1410 DIM forced_device$(20)
1420 DIM reset_pr$(32), cancel_pr$(32)
1430 DIM preamble$(32), postamble$(32)
1440 DIM eol$(32)
1450 DIM pause_key$(8)
1460 DIM boldon_key$(8), boldoff_key$(8)
1470 DIM ulinon_key$(8), ulinoff_key$(8)
1480 DIM quick%(255) : REMark Ref. tab for search strings
1490 DIM etype%(max_exchanges%) : REMark 1=XL,2=XG,4=XLS,5=TL,6=TG
1500 DIM epart%(max_exchanges%) : REMark -ptr to ON code for X type
1510                              REMark 0 = OFF for T or X type
1520                              REMark 1 = ON  for T or X type
1530 DIM eecho%(max_exchanges%) : REMark Hold area for epart% in Hddr/Footer
1540 DIM esequ%(max_exchanges%) : REMark Pointer to prior exch.
1550                              REMark  -1 = first of sequence
1560                              REMark   0 = not used so far
1570 DIM esrch$(max_exchanges%,8) : REMark Edit-time code
1580 DIM erpl1$(max_exchanges%,16) : REMark Print-time code (X ON or OFF)
1590 DIM erpl2$(max_exchanges%,16) : REMark Print-time code (T OFF)
1600 DIM info_no%(2)        : REMark Number of Header/Footer lines
1610 DIM info_pageline%(2)  : REMark 0=Page num not reqd; else which line 1-9
1620 DIM info_pagetype%(2)  : REMark 1=LJust : 2=Roman : 3+=RJust in fieldsize
1630 DIM info_pagepos%(2)   : REMark Column no of Page No on line 1
1640 DIM headfoot$(2,9,136) : REMark Header and Footer text
1650 DIM parcodes$(200)     : REMark Program constants
1660 DIM slm_prfX$(12)      : REMark Set left margin prefix
1670 DIM slm_string$(12)    : REMark Set left margin sequence
1680 DIM left_margin_fill$(60) : REMark Set to spaces if no printer seq to set margin
1690 :
1700 REMark ________________  Figurative Constants  _______________________
1710 REMark ____  Can be stripped with Editor or XLATE before compile  ____
1720  MANIFEST : TRUE = 1       : FALSE = 0
1730  MANIFEST : sym_HD% = 1    : REMark Heading text
1740  MANIFEST : sym_FT% = 2    : REMark Footing text
1750  MANIFEST : sym_PA% = 3    : REMark Preamble sequence
1760  MANIFEST : sym_PO% = 4    : REMark Postamble sequence
1770  MANIFEST : sym_PL% = 7    : REMark Logical lines per page
1780  MANIFEST : sym_HM% = 5    : REMark Header margin
1790  MANIFEST : sym_FM% = 6    : REMark Footer margin
1800  MANIFEST : sym_LM% = 8    : REMark Left margin (print offset)
1810  MANIFEST : sym_BD% = 9    : REMark Baud Rate
1820  MANIFEST : sym_DV% = 10   : REMark Printer device/file name
1830  MANIFEST : sym_PG% = 11   : REMark Page numbering on/off
1840  MANIFEST : sym_PN% = 12   : REMark Start Page number
1850  MANIFEST : sym_EL% = 13   : REMark End of line code
1860  MANIFEST : sym_SS% = 14   : REMark Single Sheet on/off
1870  MANIFEST : sym_PS% = 15   : REMark Mnemonic to be used for Pause
1880  MANIFEST : sym_PC% = 16   : REMark Column for default page number
1890  MANIFEST : sym_XG% = 17   : REMark Exchange with Global effect
1900  MANIFEST : sym_XL% = 18   : REMark Exchange with one line effect
1910  MANIFEST : sym_TG% = 19   : REMark Toggle with Global effect
1920  MANIFEST : sym_TL% = 20   : REMark Toggle with one line effect
1930  MANIFEST : sym_BO% = 21   : REMark Bold is default
1940  MANIFEST : sym_UL% = 22   : REMark Uline is default
1950  MANIFEST : sym_RS% = 23   : REMark Printer Reset string
1960  MANIFEST : sym_PB% = 24   : REMark Conditional Page
1970  MANIFEST : sym_CN% = 25   : REMark Cancel code (zap printer buffer)
1980  MANIFEST : sym_SL% = 26   : REMark Set left margin prefix
1990  MANIFEST : sym_FF% = 27   : REMark Explicit Page throws are required
2000  MANIFEST : sym_PT% = 28   : REMark Text for 'page number' line
2010  MANIFEST : F1_key% = 232 : F2_key% = 236 : F3_key% = 240
2020  MANIFEST : F4_key% = 244 : F5_key% = 248 : ESC_key% = 27
2030  MANIFEST : F4_Shft%= 246
2040  :
2050  parcodes$ = "\HD/\FT/\PA/\PO/\HM/\FM/\PL/\LM/\BD/\DV/\PG/\PN/\EL/\SS/\PS/\PC/\XG/\XL/\TG/\TL/\BO/\UL/\RS/\PB/\CN/\SL/\FF/\PT/"
2060 default_device$ = "FLP1_" : device$ = default_device$ : driver_fnm$ = ""
2070 prnm$ = '' : forced_device$ = "" : printer_forced = FALSE
2080 print_in_progress = FALSE : pageid$ = "Page: "
2090 :
2100 MODE 4
2110 RETRY_HERE
2120 OPEN #4,'scr_100x100a50x50' : OPEN #3,'scr_100x100a50x50':CLOSE #4:CLOSE #3
2130 PAPER 0
2140 REPeat main_loop
2150   Reset_WINDOWS
2160   Display_Options
2170   REPeat read_key
2180     PAPER 2 : INK 0 : AT 12,32 : PRINT '  Waiting  '; : PAPER 0
2190     print_in_progress = 0 : Get_Key : CLS 3
2200     SELect ON key_press
2210       = 27       : EXIT main_loop
2220       = F1_key%  : Get_Default_Device :Display_Options
2230       = F2_key%  : Get_Print_Device   :Display_Options
2240       = F3_key%  : Get_Printer_Type   :Display_Options
2250       = F4_key%  : NEXT main_loop
2260       = F5_key%  : IF LEN(driver_fnm$) <> 0
2270                      Commence_Spooling
2280                    ELSE 
2290                      Moan "NEED DRIVER FILE"
2300                    END IF 
2310                    Display_Options
2320       = 246
2330         REMark F9, Reposition window
2340         Move_SCREEN
2350         Display_Options
2360       =REMAINDER : NEXT read_key
2370     END SELect 
2380   END REPeat read_key
2390 END REPeat main_loop
2400 BORDER 1,0 : PAPER 0 : CLS
2410 STOP
2420 :
2430 DEFine PROCedure Display_Options
2440   AT 0,0 : PAPER 2 : INK 7
2450   PRINT "  EdtPrt v";vers$;" - Print text file   C.D. Sep 1997,   M.K. January 2000"; : CLS 4
2460   PAPER 0 : INK 4
2470   PRINT \TO 50;"Current value"
2480   PRINT  "        ESC    Quit"
2490   PRINT  "         F1    Specify File Device";TO 50;
2500   INK 7 : PRINT device$; : CLS 4 : INK 4
2510   PRINT \"         F2    Specify Print device";TO 50;
2520   INK 7 : PRINT forced_device$; : CLS 4 : INK 4
2530   PRINT \"         F3    Specify Printer Type";TO 50;
2540   INK 7 : PRINT driver_fnm$; : CLS 4 : INK 4
2550   PRINT \"         F4    Repaint screen"; : CLS 4 : INK 7 : PRINT TO 50;prnm$; : CLS 4 : INK 4
2560   PRINT \"         F5    Print a file"
2570   PRINT  "         F9    Move window"
2580 END DEFine 
2590 :
2600 DEFine PROCedure Get_Key
2610   CURSOR_ON #1! : key_press=CODE(INKEY$(#1,-1)) : CURSOR_OFF
2620   IF key_press = F4_key% : Re_Paint : Get_Key
2630 END DEFine 
2640 :
2650 DEFine PROCedure Re_Paint
2660   Reset_WINDOWS
2670   Display_Options
2680   IF NOT print_in_progress
2690     PAPER 2 : INK 0 : AT 12,32 : PRINT '  Waiting  '; : PAPER 0
2700     RETurn : END IF 
2710   AT 13,6 : INK 4 : PRINT "Enter name of input file on ";device$;": ";
2720   INK 7 : PRINT filename$ : INK 4
2730   AT 14,15 : PRINT " Destination file/device: ";
2740   INK 7 : PRINT printer$ : INK 4
2750   Start_up_Section 1
2760 END DEFine 
2770 :
2780 DEFine PROCedure Start_up_Section(painting)
2790   AT 15,0 : INK 4 : PRINT FILL$(" ",50)\FILL$(" ",50)
2800   AT 15,12 - LEN(start_page%)
2810   PRINT "Starting at Page (default=";start_page%;"): ";
2820   IF painting : INK 7 : PRINT start_page% : INK 4
2830   AT 16,10 : PRINT "Ending at Page (default=9999): ";
2840   IF painting : INK 7 : PRINT end_page% : INK 4
2850   AT 15,60 : PRINT "Page length:    "
2860   AT 16,60 : PRINT "Page Number:    "
2870   Show_Hotkeys
2880 END DEFine 
2890 :
2900 DEFine PROCedure Show_Hotkeys
2910   AT 18,10 : PRINT 'Press '; : INK 7 : PRINT 'ESC'; : INK 4
2920   PRINT ' to terminate printing'
2930   INK 7 : PRINT TO 16;' P '; : INK 4 : PRINT " to halt at page"
2940   AT 19,60 : CURSOR_ON #1!
2950 END DEFine 
2960 :
2970 DEFine PROCedure Moan(txt$)
2980   REPeat drain : IF LEN(INKEY$(#1,0))=0 : EXIT drain
2990   AT 20,20 : CLS 2 : PRINT txt$\TO 20;"Press key to continue ";
3000   BEEP 30000,20 : Get_Key
3010   AT 19,0 : CLS 2
3020 END DEFine 
3030 :
3040 DEFine PROCedure Get_Default_Device
3050   b$ = Device_Name$(device$,"Enter DEVICE on which files are to be found: ",1)
3060   IF LEN(b$) >= 5 : device$ = b$
3070 END DEFine 
3080 :
3090 DEFine FuNction Device_Name$(dflt$, txt$, test)
3100   LOCal b$(36),Checked
3110   REPeat check_name
3120     AT 14,4 : CLS 2 : CLS 3
3130     INK 4 : PRINT "CURRENTLY ";
3140     INK 7 : PRINT dflt$;
3150     INK 4 : PRINT " - PRESS ENTER TO ESCAPE"
3160     PRINT \\TO 4;txt$;
3170     INK 7 : INPUT b$ : INK 4
3180     IF NOT test : EXIT check_name
3190     IF LEN(b$)=4 : b$=b$&"_"
3200     IF LEN(b$) >= 5 : IF b$(5)<>"_" OR b$(4)<"1" OR b$(4)>"8" : b$="NO"
3210     IF LEN(b$)>32 THEN b$="NO"
3220     REMark IF LEN(b$) >= 5 OR LEN(b$)=0 : EXIT check_name
3230     IF LEN(b$)=0 : EXIT check_name
3240     Checked=DEVICE_STATUS(1,b$)
3250     IF Checked <> -7 AND Checked <> -12 THEN EXIT check_name
3260     Moan 'Must be "xxxn_ or xxxn_subname_", with n= 1 to 8'
3270   END REPeat check_name
3280   AT 13,0 : CLS 2
3290   RETurn b$
3300 END DEFine 
3310 :
3320 DEFine PROCedure Get_Print_Device
3330   b$ = Device_Name$(forced_device$,"Enter PRINTER device on which files are to be printed: ",0)
3340   IF LEN(b$) <> 0 : forced_device$ = b$ : printer_forced = TRUE
3350 END DEFine 
3360 :
3370 DEFine PROCedure Get_Printer_Type
3380   LOCal ii
3390   x$ = Resp$(14,'Driver filename (default "driver_dat"): ')
3400   IF LEN(x$)=0 : x$ = 'driver_dat'
3410   driver_fnm$ = device$ & x$
3420   x = DEVICE_STATUS(driver_fnm$)
3430   IF x <> -8 AND x <> -20
3440     Moan "Can't find " & driver_fnm$ : RETurn : END IF 
3450   OPEN_IN #4,driver_fnm$
3460   ii = 0 : col% = 0 : ct% = 0 : AT 9,0 : CLS 2
3470   REPeat nm_lp
3480     IF EOF(#4) : EXIT nm_lp
3490     IF NOT Param_Line_Found("Name") : EXIT nm_lp
3500     ct% = ct% + 1
3510     AT 14+ii,col% : INK 7 : PRINT ct%; TO col%+4;
3520     prnm$ = Decoded_String$(5)
3530     INK 2 : PRINT prnm$(1 TO Min_Int%(LEN(prnm$),76-col%))
3540     ii = ii+1
3550     IF ii > 8
3560       ii = 0 : col% = col% + 26
3570       IF col% > 52
3580         IF Selected_Printer(TRUE) : RETurn 
3590         col% = 0 : ii = 0
3600         END IF : END IF 
3610     END REPeat nm_lp
3620   IF Selected_Printer(FALSE) : RETurn 
3630   CLOSE #4
3640   PRINT \\'Update Driver file with required parameters and restart'
3650   STOP
3660 END DEFine 
3670 :
3680 DEFine FuNction Selected_Printer(cont)
3690   LOCal ii
3700   x$ = Resp$(23,'Enter ident no. of required printer type: ')
3710   AT 8,0 : CLS 2
3720   IF cont : IF x$ == 'c' : RETurn 0
3730   prt% = Max_Int%(1, '0' & x$)
3740   IF NOT Within(prt%,1,ct%) : RETurn 0
3750   SET_POSITION #4,0
3760   FOR ii = 1 TO prt% : IF NOT Param_Line_Found("Name") : RETurn 0
3770   prnm$ = Decoded_String$(5) : CLOSE #4
3780   RETurn 1
3790 END DEFine 
3800 :
3810 DEFine PROCedure Commence_Spooling
3820   single_sheet = FALSE : throws_needed = FALSE : pagenumbering = FALSE
3830   bold_is_default = FALSE : ulin_is_default = FALSE
3840 :
3850   baudrate% = 0
3860   max_usable_lines% = 60 : head_margin% = 3 : foot_margin% = 3
3870   initial_page_no% = 1 : page_no% = 0 : page_col% = 0
3880   exch_lim% = 1
3890   REMark Set up Non-break space translation
3900   etype%(1) = 4 : epart%(1) = 0 : esequ%(1) = 0
3910   esrch$(1) = CHR$(31) : erpl1$(1) = " " : erpl2$(1) = ""
3920 :
3930   preamble$ = "" : postamble$ = ""
3940   slm_prfX$ = "" : slm_string$ = "" : slm_chars% = 1 : offset% = 1
3950   printer$ = "SER1"
3960   eol$ = CHR$(10) & CHR$(13)
3970   pause_key$ = ""
3980   reset_pr$ = "" : cancel_pr$ = ""
3990   boldon_key$ = "" : boldoff_key$ = ""
4000   ulinon_key$ = "" : ulinoff_key$ = ""
4010   FOR ii = 1 TO 2
4020     info_no%(ii) = 0
4030     info_pageline%(ii) = 0
4040     info_pagetype%(ii) = 0
4050     info_pagepos%(ii) = 0
4060     FOR jj = 1 TO 9 : headfoot$(ii,jj) = ""
4070     END FOR ii
4080   Setup_Margin
4090 :
4100   AT 13,6 : INK 4 : PRINT "Enter name of input file on ";device$;": ";
4110   INK 7 : INPUT filename$ : INK 4
4120   wk = DEVICE_STATUS(device$&filename$)
4130   IF wk <> -8 AND wk <> -20
4140     Moan device$ & filename$ & " is not available" : RETurn : END IF 
4150   AT 14,20 : PRINT "Loading Driver"
4160 :
4170   print_in_progress = 1
4180   IF NOT Loaded_Driver : RETurn 
4190   AT 14,15 : INK 4 : PRINT " Destination file/device: ";
4200   INK 7 : PRINT printer$
4210   AT 15,25 : INK 4 : PRINT " Confirm (y/n): "; : Get_Key
4220   IF key_press = 27 : RETurn 
4230   IF key_press = 78 OR key_press = 110 : RETurn 
4240 :
4250   IF NOT ((('ser' INSTR printer$) = 1) OR (('par' INSTR printer$) = 1) OR (('net' INSTR printer$) = 1))
4260     DELETE printer$ : END IF 
4270   OPEN_NEW #4,printer$
4280   OPEN_IN #3,device$ & filename$
4290   IF baudrate% <> 0 : BAUD baudrate%
4300   Check_Page_Structure
4310   base_exch% = 0 : halt_at_page = FALSE
4320   end_page% = 0
4330 REMark +
4340   REPeat file_loop
4350     start_page% = end_page% + 1
4360     Start_up_Section 0
4370     AT 15, 41 : INK 7 : INPUT x$
4380     start_page% = Max_Int%(start_page%, "0" & x$)
4390     AT 16, 41 : INPUT x$ : INK 4
4400     end_page% = "0" & x$ : IF end_page% = 0 : end_page% = 9999
4410     print_enabled = 0 : keep_track = 1
4420     lines_printed_on_page% = 0 : lines_left% = 0
4430     conditional_break% = 0
4440     REPeat output_file
4450       ii = CODE(INKEY$(#1))
4460       IF ii = ESC_key% : PRINT #4;cancel_pr$; : EXIT output_file
4470       IF ii = F4_Shft% : Re_Paint
4480       IF CHR$(ii) == 'P' : halt_at_page = 1
4490       IF EOF(#3) : EXIT output_file
4500       INPUT #3,instring$
4510       IF LEN(instring$) = 0
4520         IF Printed_a_Line : NEXT output_file
4530         EXIT output_file : END IF 
4540       IF instring$(1) = ';'
4550         IF LEN(instring$) <> 1
4560           Process_Parameter Stripped_Front$(instring$(2 TO LEN(instring$)))
4570           Check_Page_Structure : END IF 
4580         NEXT output_file
4590         END IF 
4600       IF CODE(instring$(1)) = 12
4610         IF NOT Started_New_Page : EXIT output_file
4620         IF LEN(instring$) = 1
4630           instring$ = ""
4640           IF Printed_a_Line : NEXT output_file
4650           EXIT output_file : END IF 
4660         instring$ = instring$(2 TO LEN(instring$))
4670         ELSE 
4680         IF lines_left% < conditional_break% : IF NOT Started_New_Page : EXIT output_file
4690         END IF 
4700       IF NOT Printed_a_Line : EXIT output_file
4710       END REPeat output_file
4720     IF lines_left% <> 0 : Finish_Page 1
4730     IF end_page% = 9999 : EXIT file_loop
4740     AT 20,10
4750     INK 4 : PRINT "Proceed within same file (n/y): ";
4760     INK 7 : INPUT x$ : AT 20,0 : CLS 3
4770     IF NOT (x$ == "y") : EXIT file_loop
4780     END REPeat file_loop
4790   PRINT #4,postamble$; : CLOSE #3 : BEEP 9999,15
4800   CLOSE #4
4810 END DEFine 
4820 :
4830 DEFine FuNction Printed_a_Line
4840   IF lines_left% = 0 : IF NOT Started_New_Page : RETurn 0
4850   conditional_break% = 0
4860   lines_left% = lines_left% - 1
4870   IF print_enabled
4880     PRINT #4; Recalled_Mode$(1, base_exch%);left_margin_fill$;
4890     Check_for_Pause (pause_key$)
4900     PRINT #4; Translated$(instring$);EndLine$;
4910     ELSE 
4920     instring$ = Translated$(instring$) : REMark Keep History up to date
4930     END IF 
4940   RETurn 1
4950 END DEFine 
4960 :
4970 DEFine PROCedure Check_for_Pause(srch$)
4980 LOCal ii
4990   IF LEN(srch$) = 0 : RETurn 
5000   REPeat ps_lp
5010     ii = srch$ INSTR instring$
5020     IF ii = 0 : EXIT ps_lp
5030     IF NOT (srch$ = instring$(ii TO ii+LEN(srch$)-1)) : EXIT ps_lp
5040     IF ii <> 1 : PRINT #4; Translated$(instring$(1 TO ii-1));
5050     Moan "PRINT PAUSED"
5060     IF ii = LEN(instring$) : instring$ = "" : EXIT ps_lp
5070     instring$ = instring$(ii+1 TO LEN(instring$))
5080     END REPeat ps_lp
5090 END DEFine 
5100 :
5110 DEFine FuNction Recalled_Mode$(locals, base_exch%)
5120   IF base_exch% = 0 : RETurn ""
5130   ignore = (epart%(base_exch%) <= 0)
5140   IF locals
5150     ignore = (ignore OR ((etype%(base_exch%) && 1) =  0))
5160     REMark Reinstate any feature switched off by prior eol
5170     ELSE 
5180     ignore = (ignore OR ((etype%(base_exch%) && 1) <> 0))
5190     REMark Don't need locals 'cos Print_a_Line will get them
5200     END IF 
5210   IF esequ%(base_exch%) = -1
5220     IF ignore : RETurn ""
5230     RETurn erpl1$(base_exch%)
5240     END IF 
5250   IF ignore : RETurn Recalled_Mode$(locals, esequ%(base_exch%))
5260   RETurn Recalled_Mode$(locals, esequ%(base_exch%)) & erpl1$(base_exch%)
5270 END DEFine 
5280 :
5290 DEFine FuNction Full_Match(ii)
5300   IF LEN(esrch$(ii)) = 1 : RETurn 1
5310   IF (posn% + LEN(esrch$(ii)) -1) > LEN(txt$) : RETurn 0
5320   RETurn esrch$(ii) = txt$(posn% TO posn%-1+LEN(esrch$(ii)))
5330 END DEFine 
5340 :
5350 DEFine FuNction Translated$(txt$)
5360 LOCal ii, ch$(2)
5370   outstring$="" : prior_posn%=1 : posn%=0 : bold_st% =0 : ulin_st% =0
5380   REPeat read_instring
5390     posn% = posn%+1 : IF posn% > LEN(txt$) : EXIT read_instring
5400     ch$ = txt$(posn%)
5410     IF quick%(CODE(ch$)) = 0 : NEXT read_instring
5420     FOR ii = 1 TO exch_lim%
5430       IF esrch$(ii,1) = ch$
5440         IF Full_Match (ii)
5450           IF posn%-1 >= prior_posn%
5460             outstring$ = outstring$ & txt$(prior_posn% TO posn%-1)
5470             END IF 
5480           Establish_Replacement (ii)
5490           IF keep_track : IF etype%(ii) <> 4 : Build_History (ii)
5500           outstring$ = outstring$ & replacement$
5510           prior_posn% = posn% + LEN(esrch$(ii))
5520           posn% = prior_posn% -1
5530           EXIT ii : END IF 
5540         END IF 
5550       END FOR ii
5560     END REPeat read_instring
5570   IF LEN(txt$) >= prior_posn%
5580     outstring$ = outstring$ & txt$(prior_posn% TO LEN(txt$))
5590     END IF 
5600   IF bold_st% <> 0 : Check_Bold_Uline 0, bold_off%
5610   IF ulin_st% <> 0 : Check_Bold_Uline 0, ulin_off%
5620   RETurn outstring$
5630 END DEFine 
5640 :
5650 DEFine PROCedure Establish_Replacement(ii)
5660   IF etype%(ii) < 5
5670     IF epart%(ii) < 0
5680       epart%(-epart%(ii)) = 0 : Check_Bold_Uline 1, ii
5690       ELSE 
5700       epart%(ii) = 1 : Check_Bold_Uline 0, ii : END IF 
5710     ELSE 
5720     IF epart%(ii) = 0
5730       epart%(ii) = 1 : Check_Bold_Uline 0, ii
5740       ELSE 
5750       epart%(ii) = 0 : Check_Bold_Uline 2, ii
5760       END IF : END IF 
5770 END DEFine 
5780 :
5790 DEFine PROCedure Check_Bold_Uline (offsw, ii)
5800   IF NOT (bold_is_default OR ulin_is_default)
5810     IF offsw<>2 : replacement$ = erpl1$(ii) : ELSE : replacement$ = erpl2$(ii)
5820     RETurn : END IF 
5830   SELect ON ii
5840     = bold_on%, bold_off%
5850                 IF bold_st% = 0 OR (bold_on%<>bold_off% AND ii=bold_on%)
5860                   bold_st% = LEN(outstring$)+1 : replacement$ =""
5870                   ELSE 
5880                   replacement$ = FILL$(CHR$(8),LEN(outstring$)-bold_st%+1) & outstring$(bold_st% TO LEN(outstring$))
5890                   bold_st% = 0 : END IF 
5900     = ulin_on%, ulin_off%
5910                 IF ulin_st% = 0 OR (ulin_on%<>ulin_off% AND ii=ulin_on%)
5920                   ulin_st% = LEN(outstring$)+1 : replacement$ =""
5930                   ELSE 
5940                   replacement$ = FILL$(CHR$(8),LEN(outstring$)-ulin_st%+1)
5950                   replacement$ = replacement$ & FILL$('_',LEN(replacement$))
5960                   ulin_st% = 0 : END IF 
5970     = REMAINDER : IF offsw<>2
5980                     replacement$ = erpl1$(ii) : ELSE 
5990                     replacement$ = erpl2$(ii) : END IF 
6000     END SELect 
6010 END DEFine 
6020 :
6030 DEFine PROCedure Build_History(ii)
6040 LOCal jj, kk
6050   IF base_exch% = 0
6060     REMark No previous exchanges
6070     esequ%(ii) = -1 : base_exch% = ii
6080     ELSE 
6090     IF epart%(ii) < 0
6100       REMark 'switch off' - just cancel the prior 'switch on' if any
6110       kk = -epart%(ii)
6120       IF kk = base_exch%
6130         base_exch% = esequ%(kk) : esequ%(kk) = 0
6140         IF base_exch% = -1 : base_exch% = 0
6150         RETurn : END IF 
6160       IF esequ%(kk) <> 0
6170         jj = Who_points_To%(base_exch%, kk)
6180         esequ%(jj) = esequ%(kk) : esequ%(kk) = 0 : END IF 
6190       ELSE 
6200       REMark Either Toggle-type or 'switch on'
6210       IF base_exch% = ii
6220         RETurn : END IF 
6230       IF esequ%(ii) <> 0
6240         jj = Who_points_To%(base_exch%,ii)
6250         esequ%(jj) = esequ%(ii)
6260         END IF 
6270       esequ%(ii) = base_exch%
6280       base_exch% = ii
6290       END IF 
6300     END IF 
6310 END DEFine 
6320 :
6330 DEFine FuNction Who_points_To%(base_exch%,ii)
6340   IF esequ%(base_exch%) = ii : RETurn base_exch%
6350   RETurn Who_points_To%(esequ%(base_exch%),ii)
6360 END DEFine 
6370 :
6380 DEFine FuNction EndLine$
6390   IF NOT throws_needed : RETurn eol$
6400   lines_printed_on_page% = lines_printed_on_page% + 1
6410   IF lines_printed_on_page% = lpp% : RETurn CHR$(12)&CHR$(13)
6420   RETurn eol$
6430 END DEFine 
6440 :
6450 REMark -
6460 :
6470 DEFine PROCedure Check_Page_Structure
6480   head_margin% = Max_Int%(info_no%(1), head_margin%)
6490   head_feed% = head_margin% - info_no%(1) -1
6500   foot_margin% = Max_Int%(info_no%(2)+pagenumbering, foot_margin%)
6510   foot_feed% = foot_margin% - info_no%(2)-pagenumbering -1
6520   lpp% = Lines_per_Page%
6530 END DEFine 
6540 :
6550 DEFine FuNction Started_New_Page
6560   IF print_enabled : Finish_Page 0
6570   conditional_break% = 0
6580   page_no% = page_no%+1
6590   AT 16,73 : INK 7 : PRINT page_no%; : INK 4
6600   IF end_page% < page_no% : RETurn 0
6610   IF start_page% <= page_no% : print_enabled = 1
6620   lines_printed_on_page% = 0
6630   IF print_enabled
6640     IF head_feed% >= 0 : PRINT #4;EndLine$;
6650     Print_HeadFoot 1
6660     FOR ii = 1 TO head_feed% : PRINT #4;EndLine$;
6670     PRINT #4;Recalled_Mode$(0, base_exch%);
6680     END IF 
6690   lines_left% = max_usable_lines%
6700   RETurn 1
6710 END DEFine 
6720 :
6730 DEFine PROCedure Finish_Page (ending)
6740   FOR ii=1 TO lines_left%+(foot_feed%>=0) : PRINT #4;EndLine$;
6750   Print_HeadFoot 2
6760   IF pagenumbering
6770     PRINT #4,left_margin_fill$;FILL$(" ", page_col%-1);pageid$;page_no%;EndLine$;
6780     END IF 
6790   FOR ii = 1 TO foot_feed% : PRINT #4;EndLine$;
6800   PRINT #4;Recalled_Mode$(0, base_exch%);
6810   IF halt_at_page
6820     Moan 'HALTED AT PAGE - on request' : halt_at_page = 0
6830     Show_Hotkeys
6840     ELSE 
6850     IF single_sheet AND NOT ending
6860       Moan "LOAD NEXT SHEET" : Show_Hotkeys : END IF 
6870     END IF 
6880   lines_left%=0
6890 END DEFine 
6900 :
6910 DEFine PROCedure Print_HeadFoot(info_type%)
6920 LOCal ii, jj
6930   PRINT #4,reset_pr$;preamble$;slm_string$;
6940   FOR ii=1 TO exch_lim% : eecho%(ii) = epart%(ii) : epart%(ii) = 0
6950   keep_track = 0
6960   FOR ii=1 TO info_no%(info_type%)
6970     IF ii = info_pageline%(info_type%) AND info_pagepos%(info_type%) <> 0
6980       PRINT #4,left_margin_fill$;Translated$(Added_PageNo$((headfoot$(info_type%,ii))));EndLine$;
6990       ELSE 
7000       PRINT #4,left_margin_fill$;Translated$(headfoot$(info_type%,ii));EndLine$;
7010       END IF 
7020     END FOR ii
7030   keep_track = 1
7040   FOR ii=1 TO exch_lim% : epart%(ii) = eecho%(ii)
7050   PRINT #4,reset_pr$;preamble$;slm_string$;
7060 END DEFine 
7070 :
7080 DEFine FuNction Added_PageNo$(str$)
7090 LOCal ii, jj, a$(150), b$(150)
7100   jj = info_pagepos%(info_type%) : ii = info_pagetype%(info_type%)
7110   IF jj <> 1 : a$ = str$(1 TO jj-1) : ELSE : a$ = ""
7120   IF jj <= LEN(str$) : b$ = str$(jj TO LEN(str$)) : ELSE : b$ = ""
7130   SELect ON ii
7140     = 1 : RETurn a$ & page_no% & b$
7150     = 2 : RETurn a$ & Roman$(page_no%) & b$
7160     = REMAINDER 
7170           x$ = FILL$(" ",ii-1) & page_no%
7180           x$ = x$(LEN(x$)-ii+2 TO LEN(x$))
7190           RETurn a$ & x$ & b$
7200     END SELect 
7210 END DEFine 
7220 :
7230 DEFine FuNction Roman$(pg%)
7240 LOCal r$(16), ii, jj
7250   ii = pg% MOD 50
7260   jj = pg% DIV 50
7270   SELect ON jj
7280     = 0 : r$ = ""
7290     = 1 : r$ = "L"
7300     = 2 : r$ = "C"
7310     = 3 : r$ = "CL"
7320     = REMAINDER : RETurn pg%
7330     END SELect 
7340   jj = ii DIV 10
7350   ii = ii MOD 10
7360   SELect ON jj
7370     = 1 TO 3 : r$ = r$ & FILL$("x",jj)
7380     = 4 : jj = (pg% DIV 10)
7390           IF jj = 9
7400             r$ = "xC": ELSE 
7410             IF jj = 19
7420               r$ = "CxC": ELSE 
7430               r$ = r$ & "xL" : END IF : END IF 
7440     END SELect 
7450   SELect ON ii
7460     = 1 TO 3 : r$ = r$ & FILL$("i",ii)
7470     = 4      : r$ = r$ & "iv"
7480     = 5 TO 8 : r$ = r$ & "v" & FILL$("i",ii-5)
7490     = 9 : r$ = r$ & "ix"
7500     END SELect 
7510   RETurn r$
7520 END DEFine 
7530 :
7540 DEFine FuNction Decoded_String$(st%)
7550 LOCal ds$(100)
7560   st% = st%+1
7570   IF LEN(b$) < st% : RETurn ""
7580   b$ = b$(st% TO LEN(b$)) : ds$ = ''
7590   REPeat ds_lp
7600     b$ = Stripped_Front$(b$)
7610     IF LEN(b$)=0 : EXIT ds_lp
7620     IF b$(1) = ";" : EXIT ds_lp
7630     IF '#' = b$(1)
7640       IF '#' = b$(2)
7650         ds$ = ds$ & Decoded_Text$
7660         ELSE 
7670         ds$ = ds$ & Decoded_ASCII$
7680         END IF 
7690       ELSE 
7700       ds$ = ds$ & Decoded_Text$
7710       END IF 
7720     END REPeat ds_lp
7730   RETurn ds$
7740 END DEFine 
7750 :
7760 DEFine PROCedure Find_Element(omit%)
7770   ii = ',' INSTR b$ : jj = ';' INSTR b$
7780   IF ii = 0 : ii = jj
7790   IF jj = 0 : jj = ii
7800   ii = Min_Int%(ii, jj)
7810   IF ii <> 0
7820     dt$ = b$(1+omit% TO ii-1) : b$ = b$(ii TO LEN(b$))
7830     ELSE 
7840     dt$ = b$(1+omit% TO LEN(b$)) : b$ = '' : END IF 
7850 END DEFine 
7860 :
7870 DEFine FuNction Decoded_Text$
7880 LOCal dt$(100), ii, jj
7890   Find_Element 0
7900   jj = 1
7910   REPeat dt_lp
7920     IF jj > LEN(dt$) : EXIT dt_lp
7930     ii = '##' INSTR dt$(jj TO LEN(dt$))
7940     IF ii = 0 : EXIT dt_lp
7950     ii = ii + jj - 1
7960     IF ii = 1
7970       dt$ = dt$(2 TO LEN(dt$))
7980       ELSE 
7990       IF ii = LEN(dt$)-1
8000         dt$ = dt$(1 TO ii)
8010         ELSE 
8020         dt$ = dt$(1 TO ii) & dt$(ii+2 TO LEN(dt$))
8030         END IF : END IF 
8040     jj = ii + 1
8050     END REPeat dt_lp
8060   RETurn dt$
8070 END DEFine 
8080 :
8090 DEFine FuNction Decoded_ASCII$
8100 LOCal dt$(100), ii, jj
8110   Find_Element 1
8120   ii = '0' & dt$
8130   RETurn CHR$(ii)
8140 END DEFine 
8150 :
8160 DEFine FuNction Stripped_Front$(str$)
8170 LOCal ii
8180   FOR ii = 1 TO LEN(str$)
8190     IF 0 = (str$(ii) INSTR ' ,') : RETurn str$(ii TO LEN(str$))
8200     END FOR ii
8210   RETurn ''
8220 END DEFine 
8230 :
8240 DEFine FuNction Min_Int%(a%, b%)
8250   IF a% < b% : RETurn a% : ELSE : RETurn b%
8260 END DEFine 
8270 :
8280 DEFine FuNction Max_Int%(a%, b%)
8290   IF a% > b% : RETurn a% : ELSE : RETurn b%
8300 END DEFine 
8310 :
8320 DEFine FuNction Within(a%, b%, c%)
8330   RETurn a% >= b% AND a% <= c%
8340 END DEFine 
8350 :
8360 DEFine FuNction Resp$(lin%, str$)
8370   INK 4
8380   IF lin% <= 0
8390     PRINT TO 46-LEN(str$);
8400     ELSE 
8410     AT lin%, 46-LEN(str$) : END IF 
8420   PRINT str$; : CLS 4
8430   INK 7 : INPUT x$;
8440   INK 4 : IF lin% >= 0 : PRINT
8450   RETurn x$
8460 END DEFine 
8470 :
8480 DEFine FuNction Loaded_Driver
8490   OPEN_IN #4,driver_fnm$
8500   FOR ii=0 TO 255 : quick%(ii) = 0
8510   REPeat pd_lp
8520     IF NOT Param_Line_Found('Name') : RETurn 0
8530     IF prnm$ = Decoded_String$(5) : EXIT pd_lp
8540     END REPeat pd_lp
8550   abort = 0
8560   REPeat sp_lp
8570     IF EOF(#4) : EXIT sp_lp
8580     IF NOT Param_Line_Found('') : EXIT sp_lp
8590     IF ('Name' INSTR b$) = 1 : EXIT sp_lp
8600     Process_Parameter (b$)
8610     END REPeat sp_lp
8620   CLOSE #4
8630   IF printer_forced : printer$ = forced_device$
8640   IF NOT abort
8650     IF bold_is_default
8660       bold_on% = Matched_in_Table%(boldon_key$)
8670       bold_off% = Matched_in_Table%(boldoff_key$)
8680       END IF 
8690     IF ulin_is_default
8700       ulin_on% = Matched_in_Table%(ulinon_key$)
8710       ulin_off% = Matched_in_Table%(ulinoff_key$)
8720       END IF 
8730     END IF 
8740   RETurn NOT abort
8750 END DEFine 
8760 :
8770 DEFine FuNction Matched_in_Table%(str$)
8780 LOCal ii
8790   ii = 0
8800   REPeat mit_lp
8810     ii = ii + 1 : IF ii > exch_lim% : RETurn 0
8820     IF str$ = esrch$(ii) : RETurn ii
8830     END REPeat mit_lp
8840 END DEFine 
8850 :
8860 DEFine FuNction Param_Line_Found(str$)
8870   REPeat plf_lp
8880     IF EOF(#4) : RETurn 0
8890     INPUT #4,b$
8900     IF 1 <> (";" INSTR b$) OR LEN(b$) = 1 : NEXT plf_lp
8910     b$ = Stripped_Front$(b$(2 TO LEN(b$)))
8920     IF LEN(b$) < 3 : NEXT plf_lp
8930     IF NOT (b$(1) == "P") AND (1<>("Name" INSTR b$)) : NEXT plf_lp
8940     IF LEN(str$) = 0 : EXIT plf_lp
8950     IF 1 = (str$ INSTR b$) : EXIT plf_lp
8960     END REPeat plf_lp
8970   RETurn 1
8980 END DEFine 
8990 :
9000 DEFine PROCedure Process_Parameter(b$)
9010 LOCal ii, str$(8)
9020   IF LEN(b$) < 3 : RETurn 
9030   str$ = '\' & b$(2 TO 3) & '/'
9040   ii = str$ INSTR parcodes$ : IF ii = 0 : RETurn 
9050   ii = 1 + (ii-1) DIV 4
9060   SELect ON ii
9070     = sym_XG%, sym_XL% : Append_Exchange 0, (ii=sym_XG%)
9080     = sym_TG%, sym_TL% : Append_Exchange 1, (ii=sym_TG%)
9090     = sym_HD% : Get_Info 1
9100     = sym_FT% : Get_Info 2
9110     = sym_PA% : preamble$ = Decoded_String$(4)
9120     = sym_PO% : postamble$ = Decoded_String$(4)
9130     = sym_PL% : max_usable_lines% = Number%(max_usable_lines%)
9140                 lpp% = Lines_per_Page%
9150     = sym_HM% : head_margin% = Number%(head_margin%)
9160                 lpp% = Lines_per_Page%
9170     = sym_FM% : foot_margin% = Number%(foot_margin%)
9180                 lpp% = Lines_per_Page%
9190     = sym_SL% : slm_chars% = Max_Int%(1, Number%(slm_chars%))
9200                 slm_string$ = Decoded_String$(1) : REMark discard prefix
9210                 slm_prfX$ = Decoded_String$(1)
9220                 Setup_Margin
9230     = sym_LM% : offset% = Max_Int%(1, Number%(offset%))
9240                 Setup_Margin
9250     = sym_BD% : baudrate% = Number%(baudrate%)
9260     = sym_DV% : printer$ = Decoded_String$(4)
9270     = sym_SS% : single_sheet  = (0 <> Number%(1))
9280     = sym_FF% : throws_needed = (0 <> Number%(1))
9290     = sym_PG% : pagenumbering = (0 <> Number%(1))
9300     = sym_PT% : pageid$ = Decoded_String$(4)
9310     = sym_PN% : initial_page_no% = Number%(initial_page_no%)
9320                 page_no% = initial_page_no% - 1
9330     = sym_PC% : page_col% = Number%(page_col%)
9340     = sym_EL% : eol$ = Decoded_String$(4)
9350     = sym_PS% : pause_key$ = Decoded_String$(4)
9360     = sym_BO% : bold_is_default=1 : boldon_key$ = Decoded_String$(4) : boldoff_key$ = Decoded_String$(1)
9370     = sym_UL% : ulin_is_default=1 : ulinon_key$ = Decoded_String$(4) : ulinoff_key$ = Decoded_String$(1)
9380     = sym_RS% : reset_pr$ = Decoded_String$(4)
9390     = sym_CN% : cancel_pr$ = Decoded_String$(4)
9400     = sym_PB% : conditional_break% = Number%(0)
9410     END SELect 
9420 END DEFine 
9430 :
9440 DEFine PROCedure Setup_Margin
9450 LOCal slm_col$(8), ii
9460   ii = offset% - 1
9470   IF LEN(slm_prfX$) <> 0
9480     IF slm_chars% = 1
9490       slm_string$ = slm_prfX$ & CHR$(ii)
9500       ELSE 
9510       slm_col$ = FILL$("0",slm_chars%-LEN(ii)) & ii
9520       slm_string$ = slm_prfX$ & slm_col$ : END IF 
9530     left_margin_fill$ = slm_string$
9540     ELSE 
9550     left_margin_fill$ = FILL$(" ",ii) : END IF 
9560 END DEFine 
9570 :
9580 DEFine FuNction Lines_per_Page%
9590 LOCal kk
9600   kk = max_usable_lines% + head_margin% + foot_margin%
9610   AT 15,73 : INK 7 : PRINT kk : INK 4
9620   RETurn kk
9630 END DEFine 
9640 :
9650 DEFine FuNction Number%(dflt%)
9660   IF LEN(b$) < 4 : RETurn dflt%
9670   wk = Ascii_to_Dec(b$(4 TO LEN(b$)))
9680   IF wk < 32768 : RETurn wk
9690   RETurn dflt%
9700 END DEFine 
9710 :
9720 DEFine FuNction Ascii_to_Dec(txt$)
9730 LOCal num
9740   atd_pt% = 0
9750   REPeat scan
9760     atd_pt% = atd_pt% + 1 : IF atd_pt% > LEN(txt$) : RETurn 32868
9770     IF Within(CODE(txt$(atd_pt%)),48,57) : EXIT scan
9780     END REPeat scan
9790   num = 0
9800   REPeat num_lp
9810     num = num * 10 + txt$(atd_pt%)
9820     atd_pt% = atd_pt% + 1 : IF atd_pt% > LEN(txt$) : EXIT num_lp
9830     IF NOT Within(CODE(txt$(atd_pt%)),48,57) : EXIT num_lp
9840     END REPeat num_lp
9850   RETurn num
9860 END DEFine 
9870 :
9880 DEFine PROCedure Get_Info(info_type%)
9890 LOCal ii, jj, a$(136), bad
9900   ii = '0' & b$(4)
9910   IF ii = 0 : info_no%(info_type%) = 0 : RETurn 
9920   IF LEN(b$) < 5
9930     bad = 1
9940     ELSE 
9950     bad = (0 = LEN(Stripped_Front$(b$(5 TO))))
9960     END IF 
9970   IF NOT bad
9980     info_no%(info_type%) = Max_Int%(ii, info_no%(info_type%))
9990     jj = 5 + (b$(5)=" ")
10000     b$ = b$(jj TO LEN(b$)) : headfoot$(info_type%, ii) = b$
10010     ELSE 
10020     IF info_no%(info_type%) = ii : info_no%(info_type%) = ii-1
10030     headfoot$(info_type%, ii) = ""
10040     END IF 
10050   IF info_pageline%(info_type%) <> 0 : RETurn 
10060   jj = "#" INSTR b$
10070   info_pagepos%(info_type%)  = jj
10080   IF jj = 0 : info_pagetype%(info_type%) = 0 : RETurn 
10090   info_pageline%(info_type%) = ii
10100   kk = 1 : ii = LEN(b$)+1
10110   IF jj < LEN(b$)
10120     ii = jj+2
10130     IF b$(ii-1)=="R"
10140       kk = 2
10150       ELSE 
10160       ii = jj
10170       REPeat gi_lp
10180         ii = ii + 1 : IF ii > LEN(b$) : EXIT gi_lp
10190         IF NOT (b$(ii) = "#") : EXIT gi_lp
10200         kk = kk + 1 : END REPeat gi_lp
10210       kk = kk + (kk > 1) : END IF 
10220     END IF 
10230   IF jj <> 1 : a$ = b$(1 TO jj-1) : ELSE : a$ = ""
10240   IF ii > LEN(b$) : b$ = "" : ELSE : b$ = b$(ii TO LEN(b$))
10250   headfoot$(info_type%,info_pageline%(info_type%)) = a$ & b$
10260   info_pagetype%(info_type%) = kk
10270 END DEFine 
10280 :
10290 DEFine PROCedure Append_Exchange(toggle,global_ex)
10300 LOCal jj, kk, first_half%
10310   x$ = Decoded_String$(4) : REMark Ignore Label
10320   x$ = Decoded_String$(1) : REMark Edit-time ON code
10330   jj = Insertion_Slot%(0, x$) : IF abort : RETurn 
10340   esrch$(jj) = x$
10350   erpl1$(jj) = Decoded_String$(1) : REMark Print-time ON code
10360   erpl2$(jj) = ""
10370   etype%(jj) = 4*toggle + global_ex + 1
10380   epart%(jj) = 0
10390   esequ%(jj) = 0
10400   IF toggle
10410     erpl2$(jj) = Decoded_String$(1) : REMark Print-time OFF code
10420     ELSE 
10430     x$ = Decoded_String$(1) : REMark Edit-time OFF code
10440     IF LEN(x$) <> 0
10450       kk = Insertion_Slot%(jj, x$) : IF abort : RETurn 
10460       esrch$(kk) = x$                 : REMark Edit-time OFF code
10470       erpl1$(kk) = Decoded_String$(1) : REMark Print-time OFF code
10480       etype%(kk) = global_ex + 1
10490       epart%(kk) = -first_half%       : REMark Pointer to ON code
10500       ELSE 
10510       IF etype%(jj) = 1
10520         etype%(jj) = 4 : REMark Xlate is only a one-shot (e.g.# => `)
10530         REMark ELSE
10540         REMark Moan "Bad translate - no OFF code " & Exploded$(esrch$(jj))
10550         END IF 
10560       END IF 
10570     END IF 
10580 END DEFine 
10590 :
10600 DEFine FuNction Insertion_Slot%(partner%, txt$)
10610 LOCal ii, kk, part%
10620   IF exch_lim% = max_exchanges%
10630     Moan "Too many Exchange codes at " & Exploded$(txt$)
10640     abort=1 : RETurn 0 : END IF 
10650   exch_lim% = exch_lim% + 1 : first_half% = partner%
10660   quick%(CODE(txt$(1))) = 1 : REMark Set flag on 1st char
10670   FOR ii = 1 TO exch_lim% -1
10680     IF txt$ = esrch$(ii)
10690       Moan "Duplicate Exchange code " & Exploded$(txt$)
10700       exch_lim% = exch_lim%-1 : RETurn ii : END IF 
10710     IF LEN(txt$) > LEN(esrch$(ii))
10720       FOR kk = exch_lim% -1 TO ii STEP -1
10730         esrch$(kk+1) = esrch$(kk)
10740         erpl1$(kk+1) = erpl1$(kk)
10750         erpl2$(kk+1) = erpl2$(kk)
10760         etype%(kk+1) = etype%(kk)
10770         part% = ABS(epart%(kk))
10780         IF part% >= ii : part% = part%+1
10790         epart%(kk+1) = -part%
10800         esequ%(kk+1) = esequ%(kk)
10810         END FOR kk
10820       FOR kk = 1 TO ii -1
10830         part% = ABS(epart%(kk))
10840         IF part% >= ii : part% = part%+1
10850         epart%(kk) = -part%
10860         END FOR kk
10870       IF partner% >= ii : first_half% = first_half% + 1
10880       RETurn ii : END IF 
10890     END FOR ii
10900   RETurn exch_lim%
10910 END DEFine 
10920 :
10930 DEFine FuNction Exploded$(txt$)
10940 LOCal ii, wk$(50)
10950   wk$ = ""
10960   FOR ii = 1 TO LEN(txt$)
10970     wk$ = wk$ & "#" & CODE(txt$(ii)) & " "
10980     END FOR ii
10990   RETurn wk$
11000 END DEFine 
11010 :
11020 REMark - MK - Code below uses binary chop to find screen size - very quick.
11030 :
11040 DEFine PROCedure Find_SCREENSIZE
11050   LOCal ChopLoop
11060   LOCal top%,btm%,diff%
11070   ScreenWidth%=512
11080   top% = 4096
11090   btm% = 512
11100   diff% = top% - btm%
11110   IF NOT(FWINDOW%(#0,ScreenWidth%,10,0,0)>-1 AND FWINDOW%(#0,ScreenWidth%+2,10,0,0)<0) THEN 
11120     REPeat ChopLoop
11130       IF FWINDOW%(#0,ScreenWidth%,10,0,0)<0 THEN 
11140         REMark - MK - too wide, make it narrower.
11150         ScreenWidth% = ScreenWidth%-diff%
11160         diff% = diff% DIV 2
11170       END IF 
11180       IF FWINDOW%(#0,ScreenWidth%+2,10,0,0)>-1 THEN 
11190         REMark - MK - too narrow, make it wider.
11200         ScreenWidth% = ScreenWidth% + diff%
11210         diff% = diff% DIV 2
11220       END IF 
11230       IF diff% < 2 THEN diff% = 2
11240       ScreenWidth% = ScreenWidth% && -2 :REMark - MK - Make sure its even
11250       IF FWINDOW%(#0,ScreenWidth%,10,0,0)>-1 AND FWINDOW%(#0,ScreenWidth%+2,10,0,0)<0 THEN EXIT ChopLoop
11260     END REPeat ChopLoop
11270   END IF 
11280   top%  = 3072
11290   btm%  = 256
11300   diff% = top% - btm%
11310   ScreenHeight% = 256
11320   IF NOT(FWINDOW%(#0,10,ScreenHeight%,0,0)>-1 AND FWINDOW%(#0,10,ScreenHeight%+2,0,0)<0) THEN 
11330     REPeat ChopLoop
11340       IF FWINDOW%(#0,10,ScreenHeight%,0,0)<0 THEN 
11350         REMark - MK - too high, make it lower.
11360         ScreenHeight% = ScreenHeight%-diff%
11370         diff% = diff% DIV 2
11380       END IF 
11390       IF FWINDOW%(#0,10,ScreenHeight%+1,0,0)>-1
11400         REMark - MK - too low, make it higher.
11410         ScreenHeight% = ScreenHeight%+diff%
11420         diff% = diff% DIV 2
11430       END IF 
11440       IF diff% < 2 THEN diff% = 2
11450       ScreenHeight% = ScreenHeight% && -2 :REMark - MK - make sure its even.
11460       IF FWINDOW%(#0,10,ScreenHeight%,0,0)>-1 AND FWINDOW%(#0,10,ScreenHeight%+2,0,0)<0 THEN EXIT ChopLoop
11470     END REPeat ChopLoop
11480   END IF 
11490   REMark WINDOW#0;100,100,ScreenWidth% DIV 2 - 50,ScreenHeight% DIV 2 - 50
11500   WINDOW#0;ScreenWidth%,ScreenHeight%,0,0
11510   Centre_WINDOWS
11520 END DEFine Find_SCREENSIZE
11530 :
11540 DEFine PROCedure Centre_WINDOWS
11550   WindowWidth%  = 464
11560   WindowHeight% = 252
11570   WindowH%      = (ScreenWidth%  - WindowWidth%)  DIV 2
11580   WindowV%      = (ScreenHeight% - WindowHeight%) DIV 2
11590   SmallWidth%   = 262
11600   SmallHeight%  = 72
11610   Find_OFFSETS
11620 END DEFine Centre_WINDOWS
11630 :
11640 DEFine PROCedure Find_OFFSETS
11650   SmallH%       = WindowH% + (WindowWidth%  - SmallWidth% ) DIV 2
11660   SmallV%       = WindowV% + (WindowHeight% - SmallHeight%) DIV 2
11670 END DEFine Find_OFFSETS
11680 :
11690 DEFine PROCedure Move_SCREEN
11700   LOCal Checked,PosLoop
11710   WINDOW#0;ScreenWidth%,ScreenHeight%,0,0
11720   Checked=FWINDOW%(#1,WindowWidth%,WindowHeight%,WindowH%,WindowV%)
11730   IF Checked < 0 THEN 
11740    Centre_WINDOWS
11750    Reset_WINDOWS
11760    WINDOW#0;ScreenWidth%,ScreenHeight%,0,0
11770   END IF 
11780   OldhOffset%=WindowH%
11790   OldvOffset%=WindowV%
11800   REPeat PosLoop
11810     Checked=FWINDOW%(#1,WindowWidth%,WindowHeight%,WindowH%,WindowV%)
11820     INK 7
11830     PAPER 0
11840     BORDER 1,7
11850     CLS
11860     PRINT\\," to move, (With ALT=Faster) ENTER key when finished."\,"ESCape to abort move. ("&WindowH%&","&WindowV%&")";
11870     Choice=CODE(INKEY$(#1,-1))
11880     BORDER 1,0
11890     SELect ON Choice
11900       =27
11910         WindowH%=OldWindowH%
11920         WindowV%=OldWindowV%
11930         Reset_WINDOWS
11940         RETurn 
11950      =10
11960         Reset_WINDOWS
11970         RETurn 
11980      =208
11990         REMark Up
12000         WindowV%=WindowV%-(WindowV%>0)
12010      =216
12020         REMark Down
12030         Checked=FWINDOW%(#1,WindowWidth%,WindowHeight%,WindowH%,WindowV%+1)
12040         IF Checked<0 THEN NEXT PosLoop
12050         WindowV%=WindowV%+1
12060      =192
12070         REMark Left
12080         WindowH%=WindowH%-2*(WindowH%>1)
12090      =200
12100         REMark Right
12110         Checked=FWINDOW%(#1,WindowWidth%,WindowHeight%,WindowH%+2,WindowV%)
12120         IF Checked<0 THEN NEXT PosLoop
12130         WindowH%=WindowH%+2
12140       =209
12150         REMark ALT/Up
12160         WindowV%=WindowV%-8
12170         IF WindowV%<0 THEN WindowV%=0
12180       =217
12190         REMark ALT/Down
12200         Checked=FWINDOW%(#1,WindowWidth%,WindowHeight%,WindowH%,WindowV%+8)
12210         IF Checked<0 THEN NEXT PosLoop
12220         WindowV%=WindowV%+8
12230       =193
12240         REMark ALT/Left
12250         WindowH%=WindowH%-8
12260         IF WindowH%<0 THEN WindowH%=0
12270       =201
12280         REMark ALT/Right
12290         Checked=FWINDOW%(#1,WindowWidth%,WindowHeight%,WindowH%+8,WindowV%)
12300         IF Checked<0 THEN NEXT PosLoop
12310         WindowH%=WindowH%+8
12320     END SELect 
12330   END REPeat PosLoop
12340 END DEFine Move_SCREEN
12350 :
12360 DEFine PROCedure Reset_WINDOWS
12370   Find_OFFSETS
12380   WINDOW #0;WindowWidth%,WindowHeight%,WindowH%,WindowV%
12390   WINDOW WindowWidth%,WindowHeight%,WindowH%,WindowV%
12400   PAPER 0
12410   INK 4
12420   BORDER 1,7
12430   BORDER#0;1,7
12440   CLS
12450 END DEFine Reset_WINDOWS
12460 :
